;======================HERMIT'S ONE RASTERLINE MUSIC DRIVER=========================
;compiler to use: 64tass v1.5x (minimum rev361 due to the new relocation method with 'union')
;usage of illegal opcodes requires the '-i' option for 64tass (read it's manual for more info)

PLAYERADDR=$1000
SID=$d400
CHN1=SID+7*0 ;bass channel
CHN2=SID+7*1 ;solo channel
CHN3=SID+7*2 ;perc/arp/FX channel
deftempo=6 ;default tempo
defptlen=$20 ;default (hardwired) pattern-length
tablemax=$e7 ;max. length of the program-table (maximum value is $fe, but $e8 saves 1 block on disk)
seqlen=$40 ;size of orderlist/sequences
header_size=$40
authorinfo_size=40
;zeropage locations
zpcode=ptn3pt-(player.zpcode_src_end-player.zpcode_src) ;Note-player code will run here (copied here by INIT)
ptn3pt=zpeffects-2 ;pattern-pointer for channel 3 (table-index entries)
zpeffects=$f7 ;$80..$ff possible table-command targets (used to jump in table/pattern/orderlist
tempo =$f7 ;tune-tempo
sldcnt=$f8 ;sweep/slide counter value
sldspd=$f9 ;slide-speed
sldtgt=$fa ;target-index
spdcnt=$fb ;speed-counter
ptncnt=$fc ;pattern-row counter
seqcnt=$fd ;sequence-index counter
NOPcmd=$fe ;kept as 'end' or 'NOP'
tblcnt=$ff ;Waveform/control/pitch table index (Channel3)
endcmd=tblcnt ;'end' command

*=PLAYERADDR ;.align $100 -this code mustn't be split by page boundaries (would add 1 extra cycle)

playerm .macro	;put into macro to pre-process absolute addresses for relocation-table
playercode
.logical \1		;set logical compilation address (used by Soci's relocation-table generator at the end)

INIT	jmp iniTune ;cycles below:
PLAY	lda spdcnt		;3 ;maybe dcp spdcnt or lsr spdcnt		;5
		bpl dosound		;2/3
		lda tempo		;3		;CASE: spdcnt was negative at entry
		sta spdcnt		;3
		dec ptncnt		;5
		bpl	playTbl		;2/3
pattlen	lda #defptlen-1	;2
		sta ptncnt		;3
patplay	inc seqcnt		;5		;code overwritten by editor with 'bne' for pattern-playback
setPtPt	ldx seqcnt		;3
		lda seq1,x		;4
		sta ptn1pL+1	;3
		sta ptn1pH+1	;3
		lda seq2,x		;4
		sta ptn2pL+1	;3
		sta ptn2pH+1	;3
		lda seq3,x		;4
		sta ptn3pt		;3
retplay	rts				;6
dosound dec spdcnt		;5
chkCnt0	bmi setNote		;2/3
chkCnt1	beq chkProg		;2/3
playTbl	ldx tblcnt		;3		;CASE: spdcnt was between tempo and 1 at entry
		lda TblCol1,x	;4
		beq tableFx		;2/3
		sta CHN3+4		;4
		lda TblCol2,x	;4
p_mute5	sta CHN3+0		;4
		lda TblCol3,x	;4
p_mute6	sta CHN3+1		;4
		inc tblcnt		;5
		rts				;6
chkProg	ldy ptncnt		;3		;CASE: spdcnt was 1 at entry
		lax (ptn3pt),y	;5
		beq slider		;2/3
setProg	stx tblcnt		;3
		lda TblCol1,x	;4
		beq retplay ;slider ;tableFx		;2/3 - table-FX can be executed in upcoming frames too
		sta CHN3+4		;4
		lda TblCol3,x	;4
p_mute7	sta CHN3+1		;4
		inc tblcnt		;5
		rts				;6
tableFx	lda TblCol2,x	;4
		ldy TblCol3,x	;4
		bmi tblCtrl		;2/3
setSIDr	sta SID,y		;5	;effect to set SID register
		inc tblcnt		;5
		rts				;6
tblCtrl	inc tblcnt		;5 - increasing table-counter allows multiple effects but disables implicit 'end' command...
		sta $00,y		;5 - effects to control operations of player (FF-jump, etc...)
		rts				;6   (using sta(zp,x) would make it possible to set arbitrary bytes in memory)
slider	lda sldcnt		;3
		clc				;2
		adc sldspd		;2
		sta sldcnt		;3
wrSlide	ldy sldtgt		;3
		sta SID,y		;5
		rts				;6
setNote	jmp zpNote		;3
zpcode_src
.logical zpcode
zpNote	ldy ptncnt		;3		;CASE: spdcnt was 0 at entry
ptn1pL	lda ptn1l,y		;5
p_mute1	sta CHN1+0		;4
ptn1pH	lda ptn1h,y		;5
p_mute2	sta CHN1+1		;4
ptn2pL	lda ptn2l,y		;5
p_mute3	sta CHN2+0		;4
ptn2pH	lda ptn2h,y		;5
p_mute4	sta CHN2+1		;4
		rts				;6
.here
zpcode_src_end

iniTune	ldx #(zpcode_src_end-zpcode_src)
-		lda zpcode_src-1,x
		sta zpcode-1,x
		dex
		bne -
		lda #>ptn3
		sta ptn3pt+1
		stx seqcnt ;X is 0 here
		stx tblcnt
		txa ;A=X=0
		ldy #$1f
-		sta SID,y
		dey
		bpl -
		inx ;X=1
		stx spdcnt		;init tempo and row-timer
		lda #defptlen-1
		sec
		sbc offs_pos
		sta ptncnt		;init row-counter
		jsr setPtPt
softIni	ldy #(SIDinitData_end-SIDinitData)-1
-		lda SIDinitData,y
		ldx initarget,y
		sta SID,x
		dey
		bpl -
		lda zaktempo	;init tempo and row-timer
		sta tempo
		lda slidespd
		sta sldspd
		lda sldtargt
		sta sldtgt
		lda sldstart
		sta sldcnt
		jmp wrSlide
initarget .byte 3,4,6,7+3,7+4,7+6,2*7+3,2*7+5,2*7+6,$16,$17,$18 ;SID-registers to be set to 'SIDinitData' bytes of tune-header
playercode_end

;===========================================MUSIC DATA==============================================
.align $100,0
tunedata
tuneheader
tunesettings
offs_pos .byte 0   ;offset for pick-up in the tune (1st pattern starts from the middle)
zaktempo .byte 7   ;frames between pattern-rows
SIDinitData
pulsewi1 .byte $08 ;channel 1 pulsewidth
wavefrm1 .byte $21 ;channel 1 waveform/control
sustain1 .byte $F5 ;channel 1 sustain(/release)
pulsewi2 .byte $07 ;channel 2 initial pulsewidth (beginning of sweep)
wavefrm2 .byte $41 ;channel 2 waveform
sustain2 .byte $C5 ;channel 2 sustain(/release)
pulsewi3 .byte $06 ;channel 3 pulsewidth
atdecay3 .byte $00 ;channel 3 attack/decay
sustain3 .byte $F9 ;channel 3 sustain/release
cutofffr .byte $08 ;initial cutoff-frequency ($d416) (beginning of sweep)
resonswi .byte $F1 ;resonance/switch ($d417) register of SID
bandvolu .byte $1F ;filterband/volume ($d418) register of SID
SIDinitData_end
sldstart .byte $08 ;starting value of the slide
slidespd .byte $01 ;slide-speed
sldtargt .byte $16 ;slide-target (SID register, e.g. $16-cutoff-hi, $01-freq1-hi, $02-pw1-lo, whatever)
displayed_end
machtype .byte 1 ;machine-type (0-NTSC,1-PAL) the tune was composed with (for conversion between PAL/NTSC if necessary)
notemode .byte 1 ;editor setting: if arp values are notes or numbers in the table
	.fill header_size-(*-tuneheader)-authorinfo_size,0
authorinfo .text"AUTHORNAME : TUNE-TITLE...              "
tuneheader_end
;orderlist
.align (seqlen),0

seq1	.fill seqlen,0;<ptn1l
seq2	.fill seqlen,0;<ptn2l
seq3	.fill seqlen,0;<ptn3

;max. 8 of 32-row patterns
.align $100,0
ptn1l	.fill 32*8,0
.align $100,0
ptn1h	.fill 32*8,0
.align $100,0
ptn2l	.fill 32*8,0
.align $100,0
ptn2h	.fill 32*8,0
.align $100,0
ptn3	.fill 32*8,0

;Waveform-Pitch program-table (can be stripped on save, but avoid page boundaries which add 1 cycle to the indexing instructions)
.align $100,0
TblCol1 .fill $100,0
.align $100,0
TblCol2 .fill $100,0
.align $100,0
TblCol3 .fill tablemax+1,endcmd

.here			;restore physical address
tunedata_end
.endm

;================================================================================================
;Relocation table generator based on the new SID-Wizard relocator by Soci/Singular, utilizing 64tass union/struct capabilities
;Basically the player code is compiled twice to different locations. This small macro
;compares the resulting binaries and creates relocation entries for the changed addresses.

		.union	;unnamed union - creates an instance for both but at the same memory location in prg output, so 'player' will overwrite 'player2'
		 .struct
player2   #playerm PLAYERADDR+$100 ;for comparison & detection of code to relocate
		 .ends
		 .struct
player	  #playerm PLAYERADDR
		 .ends
		.endu

;create the relocation-list
relolist .var ()
         .for i=0, i < len(player), i=i+1
relodiff  .var (player2[i]-player[i]) & $ff
          .if relodiff == 0 ;Case: no difference in current code
          .elsif relodiff == 1 ;Case: difference in high-byte is $100, relocation needed in current code
relolist   .var relolist..(PLAYERADDR+i-2,) ;append relocation-list
          .else ;invalid difference in high-byte, maybe due to some tricky code
           .error "Not possible to relocate player-code at memory address ",player+i,"!"
          .fi
         .next

.align $100 ;avoid overlapping tune-data area
reloctable	.word relolist ;resulted relocation-list
			.word $0000 ;end of relocation table

;=======================================================================================================
